;###########################################################################################
; WinTreeSnap, v.2007-05-20
; http://www.geocities.com/xmemor/2lz/tinyasm.html ("tiny apps + sources (masm32)")
;###########################################################################################

.386
.model flat,stdcall
option casemap:none

include 		\masm32\include\windows.inc
include 		\masm32\include\user32.inc
include 		\masm32\include\kernel32.inc
include 		\masm32\include\gdi32.inc
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\gdi32.lib

.data

format1					db " !! USE WORD-UNWRAP + MONOSPACED FONT (Courier, FixedSys,..)",13,10,13,10
								db "Foreground:%9.8lx",13,10,"Focus:%14.8lx",13,10
								db "Cursor:    (%d,%d) >",13,10,13,10,"%184sGetWindowLong GetClassLong%113s(if unequal)",13,10
								db "Z-ord   hWnd      Parent    Owner       Tree          Status    Width  Height       "
								db "X       Y   rel.X   rel.Y     ID/10    ID/16    ThreadID  ProcessID   "
								db "Exec.file%13shInst       WndProc     WndProc    UserData  ExStyles  Styles    "
								db "C.Styles  Atom    Class%34s""SendMessage WM_GETTEXT"" /GetWindowText",13,10,13,10,0

format2					db "%5d%11.8lx%10.8lx%10.8lx %-16s %s%9d%8d%8d%8d%8d%8d%10d%9x%12.8lx%10.8lx    %-20s"
								db "%10.8lx%12.8lx%2s%9.8lx%12.8lx%10.8lx%10.8lx%10.8lx%6.4x    %-38s ""%s"" %s",13,10,0

format3					db 13,10,"OSVERSIONINFO: Windows %s  %d.%02d.%d %s",0
format4					db "wtsnap_%.4lu_%.10lu.txt",0

mesowin					db 13,10,"Message-only windows:",13,10,13,10,0

tout						db "<<WTS_timeout_error>>",0
os_							db "95",0,"98",0,"Me",0,"NT 3.51",0,"NT 4.0",0,"2000",0,"XP",0,"Server 2003",0,"Vista",0,"Server ""Longhorn""",0

stts						db 13,10,13,10,13,10," Status :  a - WS_EX_LAYERED,  Vis/Hid,  En/Dis,  Max/min,  "
								db "0/1/2/3 => hasn't region/has NULLREGION/SIMPLEREGION/COMPLEXREGION",13,10
								db "      > :  cursor over window",13,10
								db "      # :  1-st non-topmost top-level window",13,10
								db " Output :  wtsnap_[number of top-level windows]_[TickCount]",13,10,13,10,13,10
about						db "  WinTreeSnap by kero <geocities.com/xmemor>, v.2007-05-20  (init: v.2004-07-27)",13,10,13,10
z_							db 0

flag_topmost		db 0

_HWND_DESKTOP		db "HWND_DESKTOP",0
_HWND_MESSAGE		db "HWND_MESSAGE",0

.data?

hdesk						dd ?
hmess						dd ?
count						dd ?
upcount					dd ?
upcountz				dd ?
lp_bigbuffer		dd ?
hrgn						dd ?

hwndparent			dd ?
hwndowner				dd ?
hinst						dd ?
wndproc1				dd ?
wndproc2				dd ?
wproc_flag			dw ?
id							dd ?
userdata				dd ?
exstyle					dd ?
style						dd ?
class_style			dd ?
atom						dd ?
threadid				dd ?
processid				dd ?
hSnapshot				dd ?
rel_left_				dd ?
rel_top_				dd ?
parent_left_		dd ?
parent_top_			dd ?
winlevel				dd ?

status					db 7 dup(?)
shiftbuffer			db 128 dup(?)
windowfile			db MAX_PATH+1 dup(?)
winclass				db MAX_PATH+1 dup(?)
wintext1				db 128 dup(?)
wintext2				db 128 dup(?)
buffer					db 1024 dup(?)

pe32						PROCESSENTRY32 <>
osvi						OSVERSIONINFO <>
pt							POINT <>
rt							RECT <>

.code

;###########################################################################################
; instead of GetAncestor(GA_PARENT)

; GetAncestorParent proc uses ebx edi hWnd:HWND
; 	invoke GetDesktopWindow
; 	mov edi,eax
; 	invoke FindWindowEx,HWND_MESSAGE,0,0,0
; 	test eax,eax
; 	jz @f
; 	invoke GetWindowLong,eax,GWL_HWNDPARENT
; @@:
; 	mov ecx,hWnd
; 	.if ecx==edi || ecx==eax
; 		xor eax,eax
; 	.else
; 		invoke GetWindow,hWnd,GW_OWNER
; 		mov ebx,eax
; 		invoke GetWindowLong,hWnd,GWL_HWNDPARENT
; 		.if eax==0 || ebx!=0
; 			mov eax,edi
; 		.endif
; 	.endif
; 	ret
; GetAncestorParent endp

;###########################################################################################

EnCh0	proc hwnd:HWND,param:DWORD
		inc	upcount
		xor	eax,eax
		inc	eax
	 	ret
EnCh0 endp

;###########################################################################################

EnCh proc uses ebx edi esi hwnd:HWND,param:DWORD

		xor	eax,eax
		mov	byte ptr wintext2,al
		mov winlevel,eax											; top-level ?
		mov	edi,offset status
		mov	ebx,offset shiftbuffer
		mov	dword ptr [ebx],'    '
		add ebx,3

		mov eax,hwnd
		.if eax==hdesk
			mov eax,offset _HWND_DESKTOP
			jmp @f
		.elseif eax==hmess
			mov eax,offset _HWND_MESSAGE
@@:
			invoke lstrcpy,ebx,eax
		.else
			.while (eax!=hdesk && eax!=hmess)
				mov byte ptr [ebx],'.'							; build w-tree
				inc ebx
				inc winlevel
				invoke GetAncestor,eax,GA_PARENT 
;				invoke GetAncestorParent,eax
			.endw
			mov	word ptr [ebx],[0]['w']			    ; "w",0
			mov byte ptr shiftbuffer+3,' '
		.endif

		mov ebx,hwnd
		invoke GetWindowRect,ebx,addr rt
		mov byte ptr [edi],' '
		mov eax,rt.left
		cmp pt.x,eax
		jl @f
		mov eax,rt.right
		cmp pt.x,eax
		jg @f
		mov eax,rt.top
		cmp pt.y,eax
		jl @f
		mov eax,rt.bottom
		cmp pt.y,eax
		jg @f
		mov byte ptr [edi],'>'							; cursor - over window
@@:
		mov eax,rt.left
		sub rt.right,eax		
		mov eax,rt.top
		sub rt.bottom,eax

		cmp winlevel,1
		jnz @f
		inc upcount

		mov	eax,rt.left
		mov	parent_left_,eax
		mov	eax,rt.top
		mov	parent_top_,eax
@@:
		mov	eax,rt.left
		sub	eax,parent_left_
		mov	rel_left_,eax
		mov	eax,rt.top
		sub	eax,parent_top_
		mov	rel_top_,eax
                   	
		mov	dword ptr [edi+1],'mDH '				; H(idden)D(isable)m(inimized)
		invoke IsWindowVisible,ebx
		test eax,eax
		jz @f
		mov byte ptr [edi+2],'V'						; V(isible)
@@:
		invoke IsWindowEnabled,ebx
		test	eax,eax
		jz	@f
		mov	byte ptr [edi+3],'E'						; E(nable)
@@:
		invoke IsIconic,ebx
		test eax,eax
		jnz	@f
		mov	byte ptr [edi+4],'M'						; M(aximized)
		invoke IsZoomed,ebx
		test	eax,eax
		jnz	@f
		mov	byte ptr [edi+4],' '						; (normal)
@@:
		invoke GetClassName,ebx,addr winclass,MAX_PATH

		invoke SendMessageTimeout,ebx,WM_GETTEXT,127,addr wintext1,SMTO_ABORTIFHUNG,20,0			; timeout: 20 ms
		test eax,eax
		jnz @f
		invoke lstrcpy,addr wintext1,offset tout
@@:
		invoke GetWindowText,ebx,addr wintext2+1,127
		invoke lstrcmp,addr wintext1,addr wintext2+1
		test eax,eax
		jz @f
		mov	byte ptr wintext2,'/'
@@:
		invoke GetWindowLong,ebx,GWL_STYLE
		mov style,eax

		invoke GetWindowLong,ebx,GWL_EXSTYLE
		mov	exstyle,eax

		test eax,WS_EX_LAYERED
		jz	@f
		mov	byte ptr [edi+1],'a'						; a(lpha-channel)
@@:
		mov ecx,WS_EX_TOPMOST
		and eax,ecx
		mov dl,' '
		.if eax!=ecx && flag_topmost==0 && winlevel==1
			inc flag_topmost
			mov dl,'#'
		.endif
		mov byte ptr shiftbuffer+1,dl

		invoke	GetWindowRgn,ebx,hrgn
		add	al,48
		mov	byte ptr [edi+5],al							; region type: 0 ("window hasn't region" or ERROR), 1 (NULLREGION), 2 (SIMPLEREGION), 3 (COMPLEXREGION)

		invoke GetWindow,ebx,GW_OWNER
		mov hwndowner,eax

		invoke	GetWindowLong,ebx,GWL_ID
		mov	id,eax

		invoke GetAncestor,ebx,GA_PARENT
;		invoke GetAncestorParent,ebx
		mov	hwndparent,eax

		invoke	GetWindowLong,ebx,GWL_HINSTANCE 
		mov	hinst,eax

		invoke	GetWindowLong,ebx,GWL_USERDATA
		mov	userdata,eax

		invoke	GetClassLong,ebx,GCL_WNDPROC
		mov	wndproc2,eax

		invoke	GetWindowLong,ebx,GWL_WNDPROC
		mov	wndproc1,eax

		mov	byte ptr wproc_flag,20h
		cmp	eax,wndproc2										; subclassed ?
		jz	@f
		test	eax,eax
		jz	@f 		
		mov	byte ptr wproc_flag,':'
@@:
		invoke	GetClassLong,ebx,GCL_STYLE
		mov	class_style,eax

		invoke	GetClassLong,ebx,GCW_ATOM
		mov	atom,eax

		invoke	GetWindowThreadProcessId,ebx,addr processid
		mov	threadid,eax

		invoke	CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,processid
;		mov	hSnapshot,eax
		mov	esi,eax
		mov	pe32.dwSize,sizeof pe32 
		invoke	Process32First,eax,addr pe32 
@@:
		test	eax,eax
		jz	_false
		mov	eax,processid
		cmp	pe32.th32ProcessID,eax
		jz	@f
		invoke	Process32Next,esi,addr pe32
		jmp	@b
@@:
		invoke	lstrcpy,addr windowfile,addr pe32.szExeFile

;include	\masm32\include\shlwapi.inc
;includelib	\masm32\lib\shlwapi.lib
;		invoke PathStripPath,eax

 ;;;;;;;;;;;;;; Instead of PathStripPathA ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
		mov	ecx,eax
@@:
		cmp	byte ptr [eax],'\'
		jz	_slash
		cmp	byte ptr [eax],'/'
		jz	_slash
		cmp	byte ptr [eax],0 
		jz	@f 
		inc	eax
		jmp	@b
_slash:
		inc	eax
		mov	ecx,eax
		jmp	@b
@@:
		mov	eax,ecx

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;		invoke	CharLower,eax
;		jmp	@f

 ;;;;;;;;;;;;;; Instead of CharLowerA ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
;		mov	ecx,eax 
@@:
		cmp	byte ptr [ecx],0
		jz	@f
		cmp	byte ptr [ecx],'A'
		jae	_A
_next:
		inc	ecx
		jmp	@b
_A:
		cmp	byte ptr [ecx],'Z'
		jbe	_Z
		jmp	_next
_Z:
		add	byte ptr [ecx],20h
		jmp	_next
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

_false:
		mov	eax,offset windowfile
		mov	word ptr [eax],[0]['?']			; "?",0
@@:
		invoke	wsprintf,addr buffer,offset format2,count,ebx,hwndparent,hwndowner,addr shiftbuffer,\
			edi,rt.right,rt.bottom,rt.left,rt.top,rel_left_,rel_top_,id,id,threadid,\
			processid,eax,hinst,wndproc1,addr wproc_flag,wndproc2,userdata,exstyle,\
			style,class_style,atom,addr winclass,addr wintext1,addr wintext2
; 4*31
		invoke lstrcat,lp_bigbuffer,addr buffer
		invoke CloseHandle,esi
		inc count
		xor eax,eax
		inc eax
	 	ret
EnCh endp

;###########################################################################################

start:

;		call GetMessageWindow											; why we hawn't this function ?  :-)
;		mov hmess,eax

		invoke FindWindowEx,HWND_MESSAGE,0,0,0		; find any message-only window
		test eax,eax
		jz @f
		invoke GetAncestor,eax,GA_PARENT   				; find main(?) message-only (class "Message")
;		invoke GetWindowLong,eax,GWL_HWNDPARENT
@@:
		mov hmess,eax

		xor eax,eax	
		mov upcount,eax

		call GetDesktopWindow
		mov hdesk,eax

;		invoke FindWindowEx,HWND_DESKTOP,0,0,0
;		invoke GetAncestor,eax,GA_PARENT
;		mov hdesk,eax


		invoke EnumChildWindows,eax,addr EnCh0,0
		mov eax,upcount
		shl eax,10																; 1024*(number of windows) bytes
		invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
		mov lp_bigbuffer,eax

		invoke GetCursorPos,addr pt
		call GetCurrentThreadId
		mov threadid,eax
		call GetForegroundWindow
		mov count,eax
		invoke GetWindowThreadProcessId,eax,0
		push eax
		invoke AttachThreadInput,eax,threadid,1			; attach
		call GetFocus
		invoke wsprintf,addr buffer,offset format1,count,eax,pt.x,pt.y,offset z_,offset z_,offset z_,offset z_,offset z_

		invoke lstrcpy,lp_bigbuffer,addr buffer
		pop eax
		invoke AttachThreadInput,eax,threadid,0			; detach

		xor	eax,eax
		mov	count,eax
		mov	upcount,eax
		mov	wproc_flag,ax
		mov	word ptr status+5,ax

		invoke CreateRectRgn,eax,eax,eax,eax
		mov hrgn,eax

		invoke EnCh,hdesk,0
		invoke EnumChildWindows,hdesk,addr EnCh,0

		mov ecx,upcount
		mov upcountz,ecx														; number of all top-level windows

		mov eax,hmess
		test eax,eax
		jz @f

		invoke lstrcat,lp_bigbuffer,offset mesowin
		xor eax,eax
		mov count,eax
		invoke EnCh,hmess,0
		invoke EnumChildWindows,hmess,addr EnCh,0		; you see - message-only windows CAN BE ENUMERATED, MSDN isn't right :-)
@@:
		mov osvi.dwOSVersionInfoSize,sizeof osvi
		invoke GetVersionEx,addr osvi		
		mov ecx,osvi.dwMajorVersion
		mov edx,osvi.dwMinorVersion
		mov eax,osvi.dwBuildNumber
		push eax
		mov eax,osvi.dwPlatformId
		.if eax==1
			.if ecx==4
				.if edx==0 
					mov ecx,edx
				.elseif edx==10
					mov ecx,3
				.elseif edx==90
					mov ecx,6
				.endif
			.endif
			pop	eax
			and	eax,0000FFFFh
		.elseif eax==2
			.if ecx==3	; && edx==51
				mov ecx,9
			.elseif ecx==4	; && edx==0
				mov ecx,17
			.elseif ecx==5
				.if edx==0
					mov ecx,24
				.elseif edx==1
					mov ecx,29
				.elseif edx==2
					mov ecx,32
				.endif
			.elseif ecx==6
				.if edx==0
					mov ecx,44
				.endif
			.endif
			pop eax
		.endif

		invoke wsprintf,addr buffer,offset format3,addr os_+[ecx],\
							osvi.dwMajorVersion,edx,eax,\
							addr osvi.szCSDVersion

		invoke lstrcat,lp_bigbuffer,addr buffer
		invoke lstrcat,lp_bigbuffer,offset stts
		invoke lstrlen,eax
		mov	count,eax
		call GetTickCount
		invoke wsprintf,addr shiftbuffer,offset format4,upcountz,eax

		invoke CreateFile,addr shiftbuffer,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,\
						CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
		cmp	eax,INVALID_HANDLE_VALUE
		jz _exit
		push eax
		invoke WriteFile,eax,lp_bigbuffer,count,addr count,0
		call CloseHandle
_exit:
		invoke VirtualFree,lp_bigbuffer,0,MEM_RELEASE
		invoke DeleteObject,hrgn
		invoke ExitProcess,0
end	start

;###########################################################################################

; OSVERSIONINFO	STRUCT
;			dwOSVersionInfoSize   dd ?
;			dwMajorVersion        dd ?
;			dwMinorVersion        dd ?
;			dwBuildNumber         dd ?
;			dwPlatformId          dd ?
;			szCSDVersion          db 128 dup (?)
; OSVERSIONINFO	ENDS
;                        dwMajorVersion   dwMinorVersion   dwPlatformId
; Win32s on Windows 3.1                                    VER_PLATFORM_WIN32s         =0
; Windows 95	                4                0           VER_PLATFORM_WIN32_WINDOWS  =1
; Windows 98	                4               10           VER_PLATFORM_WIN32_WINDOWS
; Windows Me	                4               90           VER_PLATFORM_WIN32_WINDOWS
; Windows NT 3.5 1            3               51           VER_PLATFORM_WIN32_NT       =2
; Windows NT 4.0              4                0           VER_PLATFORM_WIN32_NT
; Windows 2000	              5                0           VER_PLATFORM_WIN32_NT
; Windows XP	                5                1           VER_PLATFORM_WIN32_NT
; Windows Server 2003         5                2           VER_PLATFORM_WIN32_NT
; Windows Vista               6                0           VER_PLATFORM_WIN32_NT
; Windows Server "Longhorn"   6                0           VER_PLATFORM_WIN32_NT

;###########################################################################################
